#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <EzGraph.h>
#include "blastoff.h"
#include "draw.h"
#include "uty.h"

#include "xpm/org/ldru.xpm"
#include "xpm/org/lxru.xpm"
#include "xpm/org/xdru.xpm"
#include "xpm/org/ldrx.xpm"
#include "xpm/org/ldxu.xpm"
#include "xpm/org/lxrx.xpm"
#include "xpm/org/xdxu.xpm"
#include "xpm/org/xxru.xpm"
#include "xpm/org/xdrx.xpm"
#include "xpm/org/lxxu.xpm"
#include "xpm/org/ldxx.xpm"
#include "xpm/org/xxxu.xpm"
#include "xpm/org/xxrx.xpm"
#include "xpm/org/xdxx.xpm"
#include "xpm/org/lxxx.xpm"
#include "xpm/org/back.xpm"
#include "xpm/org/wall.xpm"
#include "xpm/org/bomb.xpm"
#include "xpm/org/bomb2.xpm"
#include "xpm/org/fire.xpm"
#include "xpm/org/sbomb.xpm"
#include "xpm/new/smile.xpm"
#include "xpm/new/cry.xpm"
#include "xpm/cat/face.xpm"
#include "xpm/cat/face2.xpm"
#include "xpm/cat/footprint.xpm"
#include "xpm/sea/sea_back.xpm"
#include "xpm/sea/raw_squid.xpm"
#include "xpm/sea/roast_squid.xpm"
#include "xpm/sea/charcoal.xpm"
#include "xpm/sea/watermelon.xpm"

EzImage
    img_xxxu, img_xxrx, img_xxru, 
    img_xdxx, img_xdxu, img_xdrx, img_xdru, 
    img_lxxx, img_lxxu, img_lxrx, img_lxru, 
    img_ldxx, img_ldxu, img_ldrx, img_ldru, 
    img_back, img_wall, img_bomb, img_bomb2, img_fire,
    img_act_cursor, img_nact_cursor;
EzImage
    img_smile, img_cry,
    img_act_cursor_new, img_nact_cursor_new;
EzImage
    img_face, img_face2,
    img_footprint,
    img_act_cursor_cat, img_nact_cursor_cat;
EzImage
    img_sea_xxxu, img_sea_xxrx, img_sea_xxru, 
    img_sea_xdxx, img_sea_xdxu, img_sea_xdrx, img_sea_xdru, 
    img_sea_lxxx, img_sea_lxxu, img_sea_lxrx, img_sea_lxru, 
    img_sea_ldxx, img_sea_ldxu, img_sea_ldrx, img_sea_ldru, 
    img_sea_back, img_watermelon, img_raw_squid, img_roast_squid, img_charcoal,
    img_act_cursor_sea, img_nact_cursor_sea;
EzImage img_sbomb;

EzImage *img_org[] = {
    &img_back, &img_xxxu, &img_xxrx, &img_xxru, 
    &img_xdxx, &img_xdxu, &img_xdrx, &img_xdru, 
    &img_lxxx, &img_lxxu, &img_lxrx, &img_lxru, 
    &img_ldxx, &img_ldxu, &img_ldrx, &img_ldru, 
    &img_back, &img_wall, &img_bomb, &img_bomb2, &img_fire, 
    &img_act_cursor, &img_nact_cursor,
};
EzImage *img_new[] = {
    &img_back, &img_xxxu, &img_xxrx, &img_xxru, 
    &img_xdxx, &img_xdxu, &img_xdrx, &img_xdru, 
    &img_lxxx, &img_lxxu, &img_lxrx, &img_lxru, 
    &img_ldxx, &img_ldxu, &img_ldrx, &img_ldru, 
    &img_back, &img_wall, &img_smile, &img_cry, &img_fire, 
    &img_act_cursor_new, &img_nact_cursor_new,
};
EzImage *img_cat[] = {
    &img_back, &img_xxxu, &img_xxrx, &img_xxru, 
    &img_xdxx, &img_xdxu, &img_xdrx, &img_xdru, 
    &img_lxxx, &img_lxxu, &img_lxrx, &img_lxru, 
    &img_ldxx, &img_ldxu, &img_ldrx, &img_ldru, 
    &img_back, &img_footprint, &img_face, &img_face2, &img_fire, 
    &img_act_cursor_cat, &img_nact_cursor_cat,
};
EzImage *img3[] = {
    &img_sea_back, &img_sea_xxxu, &img_sea_xxrx, &img_sea_xxru, 
    &img_sea_xdxx, &img_sea_xdxu, &img_sea_xdrx, &img_sea_xdru, 
    &img_sea_lxxx, &img_sea_lxxu, &img_sea_lxrx, &img_sea_lxru, 
    &img_sea_ldxx, &img_sea_ldxu, &img_sea_ldrx, &img_sea_ldru,
    &img_sea_back, &img_watermelon, &img_raw_squid, &img_roast_squid,
    &img_charcoal, 
    &img_act_cursor_sea, &img_nact_cursor_sea,
};

EzImage **img = img_org;

fragment_t frag[JOB_BLAST_COUNT][FRAGMENT_NUM];
fragment_t frag_l[JOB_BLAST_COUNT][FRAGMENT_NUM];
fragment_t frag_ld[JOB_BLAST_COUNT][FRAGMENT_NUM];
fragment_t frag_d[JOB_BLAST_COUNT][FRAGMENT_NUM];
fragment_t frag_r[JOB_BLAST_COUNT][FRAGMENT_NUM];
fragment_t frag_rd[JOB_BLAST_COUNT][FRAGMENT_NUM];

char *xpm[1 + 256 + PAT_SIZE];
char xpm_header[128];
char xpm_colors[256][1+1+1+1+1+6+1];
char xpm_pixels[PAT_SIZE][PAT_SIZE+1];


void init_draw(void){
    // ȯѥ
    init_blast();

    // org set
    merge_and_read_xpm(ldru_xpm, back_xpm, &img_ldru);

    merge_and_read_xpm(lxru_xpm, back_xpm, &img_lxru);
    merge_and_read_xpm(xdru_xpm, back_xpm, &img_xdru);
    merge_and_read_xpm(ldrx_xpm, back_xpm, &img_ldrx);
    merge_and_read_xpm(ldxu_xpm, back_xpm, &img_ldxu);

    merge_and_read_xpm(lxrx_xpm, back_xpm, &img_lxrx);
    merge_and_read_xpm(xdxu_xpm, back_xpm, &img_xdxu);
    merge_and_read_xpm(xxru_xpm, back_xpm, &img_xxru);
    merge_and_read_xpm(xdrx_xpm, back_xpm, &img_xdrx);
    merge_and_read_xpm(lxxu_xpm, back_xpm, &img_lxxu);
    merge_and_read_xpm(ldxx_xpm, back_xpm, &img_ldxx);

    merge_and_read_xpm(xxxu_xpm, back_xpm, &img_xxxu);
    merge_and_read_xpm(xxrx_xpm, back_xpm, &img_xxrx);
    merge_and_read_xpm(xdxx_xpm, back_xpm, &img_xdxx);
    merge_and_read_xpm(lxxx_xpm, back_xpm, &img_lxxx);

    img_back = EzReadXPM(back_xpm);
    img_wall = EzReadXPM(wall_xpm);

    merge_and_read_xpm(bomb_xpm, back_xpm, &img_bomb);
    merge_and_read_xpm(bomb2_xpm, back_xpm, &img_bomb2);
    merge_and_read_xpm(bomb_xpm, back_xpm, &img_nact_cursor);
    merge_and_read_xpm(bomb2_xpm, back_xpm, &img_act_cursor);
    merge_and_read_xpm(fire_xpm, back_xpm, &img_fire);

    img_sbomb = EzReadXPM(sbomb_xpm);

    // new set
    merge_and_read_xpm(smile_xpm, back_xpm, &img_smile);
    merge_and_read_xpm(cry_xpm, back_xpm, &img_cry);
    merge_and_read_xpm(smile_xpm, back_xpm, &img_nact_cursor_new);
    merge_and_read_xpm(cry_xpm, back_xpm, &img_act_cursor_new);

    // cat set
    merge_and_read_xpm(face_xpm, back_xpm, &img_face);
    merge_and_read_xpm(face2_xpm, back_xpm, &img_face2);
    merge_and_read_xpm(face_xpm, back_xpm, &img_nact_cursor_cat);
    merge_and_read_xpm(face2_xpm, back_xpm, &img_act_cursor_cat);
    merge_and_read_xpm(footprint_xpm, back_xpm, &img_footprint);

    // sea set
    merge_and_read_xpm(ldru_xpm, sea_back_xpm, &img_sea_ldru);

    merge_and_read_xpm(lxru_xpm, sea_back_xpm, &img_sea_lxru);
    merge_and_read_xpm(xdru_xpm, sea_back_xpm, &img_sea_xdru);
    merge_and_read_xpm(ldrx_xpm, sea_back_xpm, &img_sea_ldrx);
    merge_and_read_xpm(ldxu_xpm, sea_back_xpm, &img_sea_ldxu);

    merge_and_read_xpm(lxrx_xpm, sea_back_xpm, &img_sea_lxrx);
    merge_and_read_xpm(xdxu_xpm, sea_back_xpm, &img_sea_xdxu);
    merge_and_read_xpm(xxru_xpm, sea_back_xpm, &img_sea_xxru);
    merge_and_read_xpm(xdrx_xpm, sea_back_xpm, &img_sea_xdrx);
    merge_and_read_xpm(lxxu_xpm, sea_back_xpm, &img_sea_lxxu);
    merge_and_read_xpm(ldxx_xpm, sea_back_xpm, &img_sea_ldxx);

    merge_and_read_xpm(xxxu_xpm, sea_back_xpm, &img_sea_xxxu);
    merge_and_read_xpm(xxrx_xpm, sea_back_xpm, &img_sea_xxrx);
    merge_and_read_xpm(xdxx_xpm, sea_back_xpm, &img_sea_xdxx);
    merge_and_read_xpm(lxxx_xpm, sea_back_xpm, &img_sea_lxxx);

    img_sea_back = EzReadXPM(sea_back_xpm);

    merge_and_read_xpm(raw_squid, sea_back_xpm, &img_raw_squid);
    merge_and_read_xpm(roast_squid, sea_back_xpm, &img_roast_squid);
    merge_and_read_xpm(raw_squid, sea_back_xpm, &img_nact_cursor_sea);
    merge_and_read_xpm(roast_squid, sea_back_xpm, &img_act_cursor_sea);
    merge_and_read_xpm(charcoal, sea_back_xpm, &img_charcoal);
    merge_and_read_xpm(watermelon_xpm, sea_back_xpm, &img_watermelon);
}

void merge_and_read_xpm(char *upper[], char *lower[], EzImage *img){
    char **xpm;
    xpm = merge_xpm(upper, lower);
    *img = EzReadXPM(xpm);
}

void show_xpm(void){
    int i = 0;
    int width, height, color_num, bytes;
    sscanf(xpm[0], "%d%d%d%d", &width, &height, &color_num, &bytes);
    for (i = 0 ; i < 1 + color_num + height ; i++){
        printf("%d |%s|\n", i, xpm[i]);
    }
}

// col_table[c]ʸcб뿧ؤѴơ֥
// alt_table[c]ʸcʸؤѴơ֥
char **merge_xpm(char *upper[], char *lower[]){
    int i, j;
    int width_u, height_u, cnum_u, bytes_u;
    int width_l, height_l, cnum_l, bytes_l;
    int cnum = 0;
    int col_table[256], col;
    unsigned char c, dmy, tr_c = 0, alt_c, alt_table[256] = {0};
    static unsigned char alt_chrs[]
        = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+-*/";

    sscanf(upper[0], "%d %d %d %d", &width_u, &height_u, &cnum_u, &bytes_u);
    sscanf(lower[0], "%d %d %d %d", &width_l, &height_l, &cnum_l, &bytes_l);
    if (width_u != PAT_SIZE || width_l != PAT_SIZE){
        printf("wrong width in xpm.\n");
        exit(1);
    }
    if (height_u != PAT_SIZE || height_l != PAT_SIZE){
        printf("wrong height in xpm.\n");
        exit(1);
    }
    if (bytes_u != 1 || bytes_l != 1){
        printf("wrong bytes in xpm.\n");
        exit(1);
    }

    // ơ֥
    for (i = 0 ; i < 256 ; i++){
        col_table[i] = UNUSED_COLOR;
    }

    xpm[0] = xpm_header;

    // ѥåȾ
    for (i = 0 ; i < cnum_l ; i++){
        if (sscanf(lower[i+1], "%c %c #%x", &c, &dmy, &col) == 3){
            printf("%c->%x\n", c, col);
            col_table[c] = col;
            strcpy(xpm_colors[cnum], lower[i+1]);
            xpm[cnum+1] = xpm_colors[cnum];
            cnum ++;
        }
        else if (sscanf(lower[i+1], "%c %c None", &c, &dmy) == 2){
            // ¦βƩϻȤƤʤϤʤΤ̵뤹
            // (¦βƩϺǽ˻ĤäƤޤΤǡƱΥԥϤʤϤ)
            printf("Warning: Ignore transparent color in lower layer xpm.\n");
            // οξxpm˥ԡʤ
        }
        else {
            printf("wrong color in xpm.\n");
            exit(1);
        }
    }
    for (i = 0 ; i < cnum_u ; i++){
        if (sscanf(upper[i+1], "%c %c #%x", &c, &dmy, &col) == 3){
            printf("%c->%x\n", c, col);
            if (col_table[c] == UNUSED_COLOR){
                col_table[c] = col;
                xpm[cnum+1] = xpm_colors[cnum];
                strcpy(xpm_colors[cnum], upper[i+1]);
                cnum ++;
            }
            else {
                if (col_table[c] == col){
                    printf("Warning: same palette. %c->%x\n", c, col);
                }
                else {
                    printf("Letter '%c' conflicts on merging xpm.\n", c);
                    j = 0;
                    alt_c = 0;
                    while (alt_chrs[j] != '\0'){
                        if (col_table[alt_chrs[j]] == UNUSED_COLOR){
                            alt_c = alt_chrs[j];
                            alt_table[c] = alt_c;
                            col_table[alt_c] = col;
                            xpm[cnum+1] = xpm_colors[cnum];
                            strcpy(xpm_colors[cnum], upper[i+1]);
                            xpm_colors[cnum][0] = alt_c;
                            cnum ++;
                            break;
                        }
                        j++;
                    }
                    if (alt_c == 0){
                        printf("Cannot find alternate letter for '%c'.\n", c);
                        exit(1);
                    }
                }
            }
        }
        else if (sscanf(upper[i+1], "%c %c None", &c, &dmy) == 2){
            printf("%c->tr\n", c);
            col_table[c] = TRANSPARENT_COLOR;
            tr_c = c;
            // ƩΥԥϺǽŪxpm˻ĤʤΤǡ
            // xpmο˴ޤɬפϤʤ
            /*
            xpm[cnum+1] = xpm_colors[cnum];
            strcpy(xpm_colors[cnum], upper[i+1]);
            cnum ++;
            */
        }
        else {
            printf("wrong color in xpm.\n");
            exit(1);
        }
    }
    printf("merge pixels %d %d %d\n", cnum, cnum_u, cnum_l);
    sprintf(xpm_header, "%d %d %d %d", width_u, height_u, cnum,1);

    // ԥޡ
    for (i = 0 ; i < PAT_SIZE ; i++){
        xpm[1+cnum+i] = xpm_pixels[i];
        for (j = 0 ; j < PAT_SIZE ; j++){
            if (upper[1+cnum_u+i][j] != tr_c){
                c = upper[1+cnum_u+i][j];
                alt_c = alt_table[c];
                if (alt_c != 0){
                    xpm[1+cnum+i][j] = alt_c;
                }
                else {
                    xpm[1+cnum+i][j] = c;
                }
            }
            else {
                xpm[1+cnum+i][j] = lower[1+cnum_l+i][j];
            }
        }
        xpm[1+cnum+i][PAT_SIZE] = '\0';
    }
    //    show_xpm();



    /*
      k = 1 + COLOR_NUM + 1;
    for (i = 0 ; i < PAT_SIZE ; i++){
        for (j = 0 ; j < len ; j++){
            if (upper[i+k][j] != '.'){
                xpm[i+k][j] = upper[i+k][j];
            }
            else {
                xpm[i+k][j] = lower[i+k][j];
            }
       //        strcpy(xpm[i+1+COLOR_NUM+1], upper[i+1+COLOR_NUM+1]);      
        }
        xpm[i+k][len] = '\0';
    }
    */
    /*
    for (i = 0 ; i < line_num ; i++){
        printf("%d:%s\n", i, xpm[i]);
    }
    */
    return xpm;
}

void select_img(int no){
    switch(no){
    case 0:
        img = img_org;
        break;
    case 1:
        img = img_new;
        break;
    case 2:
        img = img_cat;
        break;
    case 3:
        img = img3;
        break;
    default:
        printf("unknown img set %d\n", no);
        exit(1);
    }
    printf("switched img to no.%d\n", no);
}

// ֹnoΥѥ򥭥饯ɸ(x, y)ɽ
void patput(int x, int y, pat_no_t no){
    //    lput(x * PAT_SIZE + STAGE_LT_X, y * PAT_SIZE + STAGE_LT_Y, lpat[no]);
    EzPut(x * PAT_SIZE + STAGE_LT_X, y * PAT_SIZE + STAGE_LT_Y, *img[no]);
    //    map[x][y] = no;
}


void init_blast(void){
    make_fragment(frag,
                  -BLAST_SIZE/2, -BLAST_SIZE/2,
                   BLAST_SIZE/2,  BLAST_SIZE/2);
    make_fragment(frag_l,
                  -BLAST_SIZE/2/3, -BLAST_SIZE/2,
                   BLAST_SIZE/2,    BLAST_SIZE/2);
    make_fragment(frag_ld,
                  -BLAST_SIZE/2/3, -BLAST_SIZE/2,
                   BLAST_SIZE/2,  BLAST_SIZE/2/3);
    make_fragment(frag_d,
                  -BLAST_SIZE/2, -BLAST_SIZE/2,
                   BLAST_SIZE/2,  BLAST_SIZE/2/3);
    make_fragment(frag_rd,
                  -BLAST_SIZE/2, -BLAST_SIZE/2,
                   BLAST_SIZE/2/3,  BLAST_SIZE/2/3);
    make_fragment(frag_r,
                  -BLAST_SIZE/2, -BLAST_SIZE/2,
                   BLAST_SIZE/2/3,    BLAST_SIZE/2);
}


void make_fragment(fragment_t fragment[][FRAGMENT_NUM],
                   int left, int top, int right, int bottom)
{
    int i, t;
    int rx, ry, x, y;
    double fx, fy, vx, vy;

    for (i = 0 ; i < FRAGMENT_NUM ; i++){
        fx = 0;
        fy = 0;
        rx = 0;
        ry = 0;
        while (abs(rx) < 5 && abs(ry) < 5){
            rx = rnd(-100, 100);
            ry = rnd(-100, 100);
        }
        vx = (double)rx / FRAGMENT_SPEED;
        vy = (double)ry / FRAGMENT_SPEED;
        for (t = 0 ; t < JOB_BLAST_COUNT ; t++){
            fx += vx;
            fy += vy;
            x = (int)fx;
            y = (int)fy;
            if (x <= left+1){
                x = left + 2;
            }
            else if (x >= right-1){
                x = right - 2;
            }
            if (y <= top+1){
                y = top + 2;
            }
            else if (y >= bottom-1){
                y = bottom - 2;
            }
            fragment[t][i].x = x;
            fragment[t][i].y = y;
            fragment[t][i].rgb.r = 255;
            fragment[t][i].rgb.g = 255-t*255/JOB_BLAST_COUNT;
            fragment[t][i].rgb.b = 0;
        }
    }
}


void draw_blast(pos_t pos, int count){
    int i;
    rgb_t rgb;
    int t = JOB_BLAST_COUNT - count;
    int x, y;
    fragment_t *fragment;

    //    printf("!!!(%d,%d)\n", pos.x, pos.y);
    if (pos.y == STAGE_HEIGHT-2){
        if (pos.x == 1){
            fragment = frag_ld[t];
        }
        else if (pos.x == STAGE_WIDTH-2){
            fragment = frag_rd[t];
        }
        else {
            fragment = frag_d[t];
        }
    }
    else {
        if (pos.x == 1){
            fragment = frag_l[t];
        }
        else if (pos.x == STAGE_WIDTH-2){
            fragment = frag_r[t];
        }
        else {
            fragment = frag[t];
        }
    }

    rgb = fragment->rgb;
    EzSetColorByRGB(rgb.r, rgb.g, rgb.b);
    for (i = 0 ; i < FRAGMENT_NUM ; i++){
        /*
        EzDrawPoint(pos.x * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_X +
                        fragment[i][t-1].x,
                        pos.y * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_Y +
                        fragment[i][t-1].y);
        */        
        //        printf("%d %d\n", fragment[i][t].x,fragment[i][t].y);
        x = pos.x * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_X + fragment->x;
        y = pos.y * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_Y + fragment->y;
        //        rgb = fragment->rgb;
        //        EzSetColorByRGB(rgb.r, rgb.g, rgb.b);
        EzDrawBox(x-1, y-1, x+1, y+1);
        //        EzDrawPoint(x, y);
        fragment ++;
    }

    /*
    EzSetColorByRGB(255, 255-count*5, 0);
    EzFillCircle(pos.x * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_X,
                     pos.y * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_Y,
                     (JOB_BLAST_COUNT-count)*(PAT_SIZE*3/2) /
                     JOB_BLAST_COUNT - 1);
    */
}

void draw_fuse_fire(pos_t pos, int dir, int count, int is_in){
    pos_t p, lt, rb;
    p.x = PAT_SIZE/2 + RotX(dir)*(is_in ? PAT_SIZE/2-count: count);
    p.y = PAT_SIZE/2 + RotY(dir)*(is_in ? PAT_SIZE/2-count :count);
    lt.x = STAGE_LT_X + pos.x * PAT_SIZE +
        ((p.x >= FUSE_FIRE_SIZE) ? p.x-FUSE_FIRE_SIZE : 0);
    lt.y = STAGE_LT_Y + pos.y * PAT_SIZE +
        ((p.y >= FUSE_FIRE_SIZE) ? p.y-FUSE_FIRE_SIZE : 0);
    rb.x = STAGE_LT_X + pos.x * PAT_SIZE +
        ((p.x < PAT_SIZE-FUSE_FIRE_SIZE) ? p.x+FUSE_FIRE_SIZE : PAT_SIZE-1);
    rb.y = STAGE_LT_Y + pos.y * PAT_SIZE + 
        ((p.y < PAT_SIZE-FUSE_FIRE_SIZE) ? p.y+FUSE_FIRE_SIZE : PAT_SIZE-1);
    
    EzSetColorByRGB(255, 0, 0);
    EzFillBox(lt.x, lt.y, rb.x, rb.y);
/*
    EzFillCircle(pos.x * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_X +
                     RotX(dir)*(is_in ? PAT_SIZE/2-count: count),
                     pos.y * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_Y +
                     RotY(dir)*(is_in ? PAT_SIZE/2-count :count),
                     4);
*/
}
void erase_fuse_fire(pos_t pos, int dir, int count, int is_in){
    pos_t p, lt, rb;
    p.x = PAT_SIZE/2 + RotX(dir)*(is_in ? PAT_SIZE/2-count: count);
    p.y = PAT_SIZE/2 + RotY(dir)*(is_in ? PAT_SIZE/2-count :count);
    lt.x = STAGE_LT_X + pos.x * PAT_SIZE +
        ((p.x >= FUSE_ASH_SIZE) ? p.x-FUSE_ASH_SIZE : 0);
    lt.y = STAGE_LT_Y + pos.y * PAT_SIZE +
        ((p.y >= FUSE_ASH_SIZE) ? p.y-FUSE_ASH_SIZE : 0);
    rb.x = STAGE_LT_X + pos.x * PAT_SIZE +
        ((p.x < PAT_SIZE-FUSE_ASH_SIZE) ? p.x+FUSE_ASH_SIZE : PAT_SIZE-1);
    rb.y = STAGE_LT_Y + pos.y * PAT_SIZE + 
        ((p.y < PAT_SIZE-FUSE_ASH_SIZE) ? p.y+FUSE_ASH_SIZE : PAT_SIZE-1);

    EzSetColorByRGB(160, 160, 160);
    EzFillBox(lt.x, lt.y, rb.x, rb.y);
/*
    EzFillCircle(pos.x * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_X +
                     RotX(dir)*(is_in ? PAT_SIZE/2-count: count),
                     pos.y * PAT_SIZE + PAT_SIZE/2 + STAGE_LT_Y +
                     RotY(dir)*(is_in ? PAT_SIZE/2-count :count),
                     4);
*/
}


void draw_piece_frame(int x1, int y1, int x2, int y2){
    if (x1 > x2){
        swap(&x1, &x2);
    }
    if (y1 > y2){
        swap(&y1, &y2);
    }
    //    EzSetColorByRGB(180,180,180);
    EzDrawBox(x1 * PAT_SIZE + STAGE_LT_X,
              y1 * PAT_SIZE + STAGE_LT_Y,
              x2 * PAT_SIZE + STAGE_LT_X + PAT_SIZE-1,
              y2 * PAT_SIZE + STAGE_LT_Y + PAT_SIZE-1);
}

void draw_bold(int x, int y, char *str){
    EzDrawString(x, y, str);
    EzDrawString(x+1, y, str);
}


void draw_insert_line_countdown(int count){
    static int prev_count = 0;
    //    char buf[256];
    int i;

    // 󤫤ĥȥ󤷤Ȥϡľä
    if (count == prev_count - 1){
        EzSetColorByRGB(0, 0, 0);
        EzFillBox(count*12, 0, count*12+11, 11);
    }
    // ʳ(ʤ)ϥʬ¤٤
    else {
        EzSetColorByRGB(0, 0, 0);
        EzFillBox(0, 0, 12*INSERT_LINE_INTERVAL_INIT+11, 11);
        for (i = 0 ; i < count ; i++){
            EzPut(i * 12, 0, img_sbomb);
        }
    }
    prev_count = count;
}

