#ifndef DRAW_H
#define DRAW_H
#include "blastoff.h"

// ѥΰդΥԥ
#define PAT_SIZE 24

#define PATLINE_MAX 256
// ơΰ躸ɸ
#define STAGE_LT_X 8
#define STAGE_LT_Y 32

#define FUSE_FIRE_SIZE 3
#define FUSE_ASH_SIZE 4

#define UNUSED_COLOR -1
#define TRANSPARENT_COLOR -2


typedef struct {
    int r, g, b;
} rgb_t;

typedef struct {
    int y;
    int sx, ex;
    int color;
} linfo_t;

typedef struct {
    int num;
    linfo_t linfo[PATLINE_MAX];
    rgb_t rgb_table[16];
} lpat_t;

#define BLAST_SIZE (PAT_SIZE*3)
#define FRAGMENT_NUM 100
#define FRAGMENT_SPEED 50

typedef struct {
    int x;
    int y;
    rgb_t rgb;        
} fragment_t;

void init_draw(void);
char **merge_xpm(char *upper[], char *lower[]);
void merge_and_read_xpm(char *upper[], char *lower[], EzImage *img);
void select_img(int no);
void patput(int x, int y, pat_no_t no);
void init_blast(void);
void make_fragment(fragment_t fragment[][FRAGMENT_NUM],
                   int lt_x, int lt_y, int rb_x, int rb_y);
void draw_blast(pos_t pos, int count);
void draw_fuse_fire(pos_t pos, int dir, int count, int is_in);
void erase_fuse_fire(pos_t pos, int dir, int count, int is_in);
void draw_piece_frame(int x1, int y1, int x2, int y2);
void draw_bold(int x, int y, char *str);
void draw_insert_line_countdown(int count);
#endif
