#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <EzGraph.h>
#include "config.h"
#include "blastoff.h"
#include "draw.h"
#include "console.h"
#include "uty.h"

int version = VERSION;
config_t config = {
    {
        0,                   // start level  0:0, 1:20, 2:40
        0,                   // piece init pos  0:fixed, 1:random
        0,                   // graphic  0:normal, 1:random
        0                    // END
    }
};
char *exe_dir;

map_t map[STAGE_WIDTH][STAGE_HEIGHT];
int map_obj_num;
piece_t piece, next_piece;
blocks_t blocks_old;
int is_pause = FALSE;
int drop_speed, drop_speed_org;
move_t move;

job_t job[JOB_MAX];
job_t *free_queue;
job_t *job_queue[jt_end];

// ƥ֥åνиΨ(ñ:%)
// !!! ٥Ѳ뤿ᡢƽǤ褦ˤɬפ
int block_prob_init[bt_end] = {
    /*
    30,
    30,
    10, 10, 10, 10
    */
    /*
    10,
    20,
    20, 20, 20, 10
    */
    15,
    20,
    20, 20, 15, 10
};
int block_prob[bt_end];

// 0-99ǤΥơ֥ȡ֥åפޤ
block_type_t prob_table[100];

block_type_t prob_change_bt;


achievements_t achievements = {0};
int score;
int level;
// ˲
int blast_num; 
// Blast Off
int blastoff_num;
// ٥륢åѤ˿󥿡٥륢å0
int blast_count;
game_state_t game_state;
int title_cmd, title_cmd_old;
int config_no, config_no_old;
int option_no, option_no_old;
int demo_count;
int gameover_count;
int enable_blastoff;
int insert_line_countdown;
int insert_line_interval;

char title_pat[8][13] = {
//  "01234567890123",

    "110200c0a3363",
    "10120a4920020",
    "11020735b3920",
    "1012020200220",
    "110b3507338e0",
    "0000000a9a3a3",
    "0000000227373",
    "0000000b82020",
};

pat_no_t title_pat_no[16] = {
    pt_back, pt_bomb,                    // 01
    pt_lxrx, pt_xdxu,                    // 23
    pt_xdru, pt_lxru, pt_ldxu, pt_ldrx,  // 4567
    pt_xxru, pt_lxxu, pt_ldxx, pt_xdrx,  // 89ab
    pt_lxxx, pt_xdxx, pt_xxrx, pt_xxxu,  // cdef
};

char *config_str[] = {
    "ϥ٥",
    "ԡи",
    "եå",
};
char *options_str[][4] = {
    {"1", "11", "21", "31"},
    {"", ""},
    {"", "", "ǭ", ""},
};
int options_num[] = {
    4,
    2,
    4,
    1, // 꽪λפʬ
};
#define CONFIG_NUM (sizeof(config_str)/sizeof(char*))




void init_demo(void){
    init_stage();
    demo_count = 0;
}

void draw_title(void){
    int i;
    char *cmd_str[] = {
        "START",
        "ACHIEVEMENTS",
        "CONFIGURATION",
        "QUIT"
    };
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < 4 ; i++){
        draw_bold(PAT_SIZE*3+STAGE_LT_X+2,
                  PAT_SIZE*(i+14)+STAGE_LT_Y-4, cmd_str[i]);
    }
    draw_title_cursor(title_cmd);
}

void draw_title_cursor(int cmd){
    pos_t pos;
    pos.x = 2;
    pos.y = cmd + 13;
    put_chr(pos, pt_act_cursor);
}

void erase_title_cursor(int cmd){
    pos_t pos;
    pos.x = 2;
    pos.y = cmd + 13;
    put_chr(pos, pt_back);
}


int main(int argc, char *argv[]){

    exe_dir = get_exe_dir(argv[0]);
    EzOpenWindow(CLIENT_WIDTH, CLIENT_HEIGHT);
    init();
    // initˤǡǤƤredrawϿ
    // !!! redraw٤Ƥľƻߤޤ뤳ȤΤǡ
    // ȤꤢExposeHandlerϿʤǤ
    //    EzSetExposeHandler(redraw);
    change_game_state(gs_demo);

    EzEventLoop();
    final();
    return 0;
}


void init(void){
    /*
    char *font =
        "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-jisx0201.1976-*,"
        "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-jisx0208.1983-*,"
        "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-iso8859-*";
        EzSetFont(font);
    */
    if (load_config() != 0){
        printf("Warning: loading '%s' failed.\n", CONFIG_FILE);
    }
    if (load_achievements() != 0){
        printf("Warning: loading '%s' failed.\n", ACHIEVEMENTS_FILE);
    }
    srand(time(NULL));
    init_draw();
    init_screen();
}

void final(void){
    if (save_achievements() != 0){
        printf("Error: saving '%s' failed.\n", ACHIEVEMENTS_FILE);
        exit(1);
    }
    if (save_config() != 0){
        printf("Error: saving '%s' failed.\n", CONFIG_FILE);
        exit(1);
    }
    printf("Bye.\n");
    exit(0);
}


void init_game(void){
    // ֥塼֤᤹
    // СǳݤƤΤǡ೫Ϥ٤˸ƤľФ褤
    init_job();
    // ƥ֥åиΨ֤᤹
    // ˽иΨѲΤǡ೫Ϥ٤᤹
    init_prob();

    achievements.total_play_num ++;
    init_stage();
    set_score(0);
    insert_line_interval = INSERT_LINE_INTERVAL_INIT;
    drop_speed_org = drop_speed = DROP_SPEED_INIT;
    
    blast_num = 0;
    blastoff_num = 0;
    blast_count = 0;
    map_obj_num = 0;
    enable_blastoff = FALSE;

    set_level(atoi(options_str[ci_start_level][config.options[ci_start_level]]));
    make_next_piece();
    make_new_piece();
    // insert_line_intervalset_level()ѹ뤿ᤳcountdown
    insert_line_countdown = insert_line_interval;
    draw_insert_line_countdown(insert_line_countdown);
    put_piece();
}

void init_config(void){
    init_stage();
    config_no = 0;
    option_no = config.options[config_no];
    draw_config();
    draw_config_all_cursor();
}

// ưľ˰ƤФ졢Τ
void init_screen(void){
    select_img(config.options[ci_graphic]);
    draw_screen();
    init_stage();
}


void draw_screen(void){
    int x, y;

    for (x = STAGE_WIDTH ; x < STAGE_WIDTH+6 ; x++){
        patput(x, 3, pt_wall);
    }
    for (y = 4 ; y < 6 ; y++){
        patput(STAGE_WIDTH, y, pt_wall);
        for (x = STAGE_WIDTH+2 ; x < STAGE_WIDTH+6 ; x++){
            patput(x, y, pt_wall);
        }
    }
    for (x = STAGE_WIDTH ; x < STAGE_WIDTH+6 ; x++){
        patput(x, 6, pt_wall);
    }

    EzSetFontSize(24);
    EzSetColorByRGB(255, 0, 0);
    EzDrawString(STAGE_WIDTH*24+24, 24, "Blast Off");
    EzDrawString(STAGE_WIDTH*24+25, 25, "Blast Off");
    EzSetFontSize(16);
    EzSetColorByRGB(255, 255, 255);
    EzDrawString(STAGE_WIDTH*24+16, 48, "TopScore");
    draw_top_score();
    EzDrawString(STAGE_WIDTH*24+16, 72, "Score");
    draw_score();
    EzDrawString(STAGE_WIDTH*24+16, 96, "Level");
    draw_level();
}


// ೫Ϥ䥿ȥ롦ǥܹԻʤɤ˸ƤФ졢
// ̤Υơʬ
void init_stage(void){
    pos_t pos;

    for (pos.y = 0 ; pos.y < STAGE_HEIGHT-1 ; pos.y++){
        pos.x = 0;
        put_chr(pos, pt_wall);
        for (pos.x = 1 ; pos.x < STAGE_WIDTH-1 ; pos.x++){
            put_chr(pos, pt_back);
        }
        put_chr(pos, pt_wall);
    }
    for (pos.x = 0 ; pos.x < STAGE_WIDTH ; pos.x++){
        put_chr(pos, pt_wall);
    }
}

void init_job(void){
    int i;
    job_type_t type;
    job[0].prev = NULL;
    job[0].next = &job[1];
    for (i = 1 ; i < JOB_MAX-1 ; i++){
        job[i].next = &job[i+1];
    }
    job[JOB_MAX-1].prev = &job[JOB_MAX-2];
    job[JOB_MAX-1].next = NULL;
    
    free_queue = &job[0];
    for (type = jt_begin ; type < jt_end ; type++){
        job_queue[type] = NULL;
    }
}


void push_queue(job_t **queue, job_t *job){
    if (*queue == NULL){
        job->next = NULL;
    }
    else {
        (*queue)->prev = job;
        job->next = *queue;
    }
    job->prev = NULL;
    *queue = job;
}

job_t *pop_queue(job_t **queue){
    job_t *job;
    if (*queue != NULL){
        job = *queue;
        *queue = job->next;
        if (job->next != NULL){
            job->next->prev = NULL;
        }
        return job;
    }
    else {
        return NULL;
    }
}

// queuejob
void remove_queue(job_t **queue, job_t *job){
    if (job->prev != NULL){
        job->prev->next = job->next;
    }
    else {
        *queue = job->next;
    }
    if (job->next != NULL){
        job->next->prev = job->prev;
    }
}


job_t *create_job(job_type_t type, pos_t pos){
    job_t *job;
    job = pop_queue(&free_queue);
    if (job != NULL){
        printf("create_job type:%d %p\n", type, job);
        job->pos = pos;
        job->type = type;
        set_map_job(pos, type, job);
        push_queue(&job_queue[type], job);
        return job;
    }
    else {
        printf("free queue empty!\n");
        exit(1);
    }
}

void destroy_job(job_t *job){
    printf("destroy_job %d %p %p %p\n", job->type, job->prev, job, job->next);
    remove_queue(&job_queue[job->type], job);
    reset_map_job(job->pos, job->type);
    //    printf("job_queue:%p free:%p\n", job_queue[job->type], free_queue);
    //    print_queue(job_queue[job->type]);
    //    print_queue(free_queue);
    push_queue(&free_queue, job);
    //    printf("job_queue:%p free:%p\n", job_queue[job->type], free_queue);
    //    print_queue(job_queue[job->type]);
    //    print_queue(free_queue);
    //    exit(1);
}

void change_game_state(game_state_t new_state){
    move = mv_none; // Ĥʤ褦ˡơѹϥꥢ
    switch(new_state){
    case gs_playing:
        EzSetKeyHandler(playing_keyh);
        EzSetTimerHandler(playing_timerh, GAME_SPEED);
        break;
    case gs_pause:
        printf("chg state: pause\n");
        EzSetTimerHandler(NULL, GAME_SPEED);
        break;
    case gs_gameover:
        gameover_count = 0;
        EzSetKeyHandler(gameover_keyh);
        EzSetTimerHandler(gameover_timerh, GAME_SPEED);
        break;
    case gs_title:
        draw_title();
        show_help();
        EzSetKeyHandler(title_keyh);
        EzSetTimerHandler(title_timerh, GAME_SPEED);
        break;
    case gs_demo:
        init_demo();
        EzSetKeyHandler(demo_keyh);
        EzSetTimerHandler(demo_timerh, GAME_SPEED);
        break;
    case gs_achievements:
        draw_achievements();
        EzSetKeyHandler(achievements_keyh);
        EzSetTimerHandler(achievements_timerh, GAME_SPEED);
        break;
    case gs_config:
        init_config();
        EzSetKeyHandler(config_keyh);
        EzSetTimerHandler(config_timerh, GAME_SPEED);
        break;
    default:
        printf("Error: Unknown game state.");
        exit(1);
    }
    game_state = new_state;
}


void playing_keyh(int key){
    printf("key:%d '%c'\n", key, key);
    // ʤˤƤ顢®
    drop_speed = drop_speed_org;
    switch (key){
    case 'j':
    case EZ_Left:
        move = mv_left;
        break;
    case 'l':
    case EZ_Right:
        move = mv_right;
        break;
    case 'k':
    case EZ_Down:
        move = mv_down;
        break;
    case 'i':
    case 'x':
    case EZ_Up:
        move = mv_rotr;
        break;
    case 'z':
      move = mv_rotl;
      break;
    case ' ':
        drop_speed = 1;
        break;
    case 'p':
        printf("p:%d\n", game_state);
        if (game_state == gs_pause){
            put_console("߲");
            change_game_state(gs_playing);
        }
        else {
            put_console("");
            change_game_state(gs_pause);
        }
        break;
    case 'q':
        change_game_state(gs_gameover);
        break;
    case 's':
        show_status();
        break;
    case 'v':
        show_version();
        break;
    case 'w':
        show_job();
        break;
    case 'h':
    case 13:
        show_help();
        break;
    default:
        printf("%d", key);
    }
}


void playing_timerh(void){
    int i;
    job_t *new_job;

    //    start_timer_handler();
    process_job();

    save_blocks();
    piece.drop_count ++;
    if (piece.drop_count >= drop_speed){
        piece.blocks.pos[0].y++;
        piece.blocks.pos[1].y++;
        piece.drop_count = 0;
        for (i = 0 ; i < 2 ; i++){
            //            printf("test;%d\n", i);
            if (check_map(piece.blocks.pos[i]) != pt_back){
                piece.fall_ix += (1-i)+1;
            }
        }
        // ʤȤϤ顢ΥԡΥɥåפϽλ
        if (piece.fall_ix > -1){
            printf("two block landed.\n");
            restore_blocks();
            for (i = 0 ; i < 2 ; i++){
                put_chr(piece.blocks.pos[i], piece.blocks.pat[i]);
                //                set_block(piece.blocks.pos[i], piece.blocks.pat[i]);
            }
            // ɤ餫Υ֥åϤƤʤȤ
            if (piece.fall_ix < 2){
                // ̤ϥ֥åfall֤
                new_job = create_job(jt_fall, piece.blocks.pos[piece.fall_ix]);
            }
            if (make_new_piece() != 0){
                change_game_state(gs_gameover);
                //                set_timer_handler(gameover_timerh, GAME_SPEED);
            }
            else {
                insert_line_countdown --;
                if (insert_line_countdown <= 0){
                    insert_line_countdown = insert_line_interval;
                    insert_line();
                }
                draw_insert_line_countdown(insert_line_countdown);
                //                EzSetTimerHandler(playing_timerh, GAME_SPEED);                
            }
            return;
        }
    }
    else if (move != 0){
        switch(move){
        case mv_left:
            piece.blocks.pos[0].x --;
            break;
        case mv_right:
            piece.blocks.pos[0].x ++;
            break;
        case mv_down:
            piece.drop_count = drop_speed - 1;
            break;
        case mv_rotr:
            piece.blocks.dir = (piece.blocks.dir+1) % 4;
            printf("dir:%d\n", piece.blocks.dir);
            for (i = 0 ; i < 2 ; i++){
                if (piece.blocks.pat[i] <= pt_ldru){
                    piece.blocks.pat[i] = RotateRight(piece.blocks.pat[i]);
                }
            }
            break;
        case mv_rotl:
            piece.blocks.dir = (piece.blocks.dir+3) % 4;
            printf("dir:%d\n", piece.blocks.dir);
            for (i = 0 ; i < 2 ; i++){
                if (piece.blocks.pat[i] <= pt_ldru){
                    piece.blocks.pat[i] = RotateLeft(piece.blocks.pat[i]);
                }
            }
            break;
        default:
            break;
        }
        set_b2_pos();
        if (check_map(piece.blocks.pos[0]) != pt_back ||
            check_map(piece.blocks.pos[1]) != pt_back)
        {
            printf("cannot move\n");
            restore_blocks();
        }
        move = 0;
    }
    if (blocks_moved()){
        erase_piece();
        put_piece();
    }
    //    EzSetTimerHandler(playing_timerh, GAME_SPEED);                
}


void gameover_keyh(int key){
    switch (key){
    case 'q':
        init_stage();
        change_game_state(gs_title);
        break;
    case 'r':
        init_game();
        change_game_state(gs_playing);
        break;
    }
}

void gameover_timerh(void){
    char *msg = "GAMEOVER";
    char buf[2] = "\0\0";
    
    //    start_timer_handler();
    if (gameover_count/8 < strlen(msg)){
        EzSetColorByRGB(255, 0, 0);
        buf[0] = msg[gameover_count/8];
        EzDrawString(60+gameover_count/8*20, 200, buf);
    }
    else {
        EzSetColorByRGB(255, 255, 0);
        EzDrawString(80, 240, "[R]: REPLAY");
    }
    gameover_count ++;
    if (gameover_count > GAMEOVER_COUNT){
        gameover_count = 0;
        change_game_state(gs_demo);
    }
    else {
        EzSetTimerHandler(gameover_timerh, GAME_SPEED);
    }
}

void title_keyh(int key){
    switch (key){
    case 'k':
    case EZ_Down:
        move = mv_down;
        break;
    case 'i':
    case EZ_Up:
        move = mv_up;
        break;
    case ' ':
    case 13:
    case 'z':
        move = mv_ok;
        break;
    case 's':
        init_game();
        change_game_state(gs_playing);
        break;
    case 'a':
        change_game_state(gs_achievements);
        break;
    case 'c':
        init_config();
        change_game_state(gs_config);
        break;
    case 'q':
        EzExitEventLoop();
        //        final();
        break;
    }
}

void title_timerh(void){
    switch (move){
    case mv_down:
        erase_title_cursor(title_cmd);
        title_cmd = (title_cmd+1) % 4;
        draw_title_cursor(title_cmd);
        break;
    case mv_up:
        erase_title_cursor(title_cmd);
        title_cmd = (title_cmd+3) % 4;
        draw_title_cursor(title_cmd);
        break;
    case mv_ok:
        switch (title_cmd){
        case 0:
            init_game();
            change_game_state(gs_playing);
            return ;
        case 1:
            change_game_state(gs_achievements);
            return;
        case 2:
            change_game_state(gs_config);
            return;
        case 3:
            EzExitEventLoop();
            return;
        }
        break;
    case mv_none:
        break;
    default:
        printf("Error: Unknown move in title.");
        exit(1);
    }
    move = mv_none;
    //    EzSetTimerHandler(title_timerh, GAME_SPEED);    
}

void demo_keyh(int key){
    switch (key){
    case 'q':
        EzExitEventLoop();
        //        final();
        break;
    default:
        change_game_state(gs_title);
        break;
    }
}

void demo_timerh(void){
    int x, c;
    pos_t pos;

    //    printf("demo_timer\n");
    //    start_timer_handler();
    if (demo_count < 13){
        for (x = 0 ; x < 8 ; x++){
            pos.x = 8 - x;
            pos.y = demo_count;
            c = title_pat[x][demo_count];
            if (c >= '0' && c <= '9'){
                c = c - '0';
            }
            else if (c >= 'a' && c <= 'z'){
                c = c - 'a' + 10;
            }
            put_chr(pos, title_pat_no[c]);
        }
        demo_count ++;
        EzSetTimerHandler(demo_timerh, GAME_SPEED);
    }
    else {
        change_game_state(gs_title);
    }
}

void achievements_keyh(int key){
    init_stage();
    change_game_state(gs_demo);
}

void config_keyh(int key){
    switch (key){
    case 'k':
    case EZ_Down:
        move = mv_down;
        break;
    case 'i':
    case EZ_Up:
        move = mv_up;
        break;
    case 'j':
    case EZ_Left:
        move = mv_left;
        break;
    case 'l':
    case EZ_Right:
        move = mv_right;
        break;
    case ' ':
    case 13:
    case 'z':
        move = mv_ok;
        break;
    case 'q':
        change_game_state(gs_demo);
        break;
    }
}

void achievements_timerh(void){
}

void config_timerh(void){
    switch (move){
    case mv_down:
        if (config_no == CONFIG_NUM){
            erase_config_cursor(config_no, option_no);
        }
        else {
            draw_config_cursor(config_no, option_no, FALSE);
        }
        config_no = (config_no+1) % (CONFIG_NUM+1);
        option_no = config.options[config_no];
        draw_config_cursor(config_no, option_no, TRUE);
        break;
    case mv_up:
        if (config_no == CONFIG_NUM){
            erase_config_cursor(config_no, option_no);
        }
        else {
            draw_config_cursor(config_no, option_no, FALSE);
        }
        config_no = (config_no+CONFIG_NUM+1-1) % (CONFIG_NUM+1);
        option_no = config.options[config_no];
        draw_config_cursor(config_no, option_no, TRUE);
        break;
    case mv_left:
        erase_config_cursor(config_no, option_no);
        option_no = (option_no+options_num[config_no]-1) % (options_num[config_no]);
        config.options[config_no] = option_no;
        draw_config_cursor(config_no, option_no, TRUE);
        if (config_no == ci_graphic){
            select_img(option_no);
            draw_screen();
            draw_config();
            draw_config_all_cursor();
        }
        break;
    case mv_right:
        erase_config_cursor(config_no, option_no);
        option_no = (option_no+1) % (options_num[config_no]);
        config.options[config_no] = option_no;
        draw_config_cursor(config_no, option_no, TRUE);
        if (config_no == ci_graphic){
            select_img(option_no);
            draw_screen();
            draw_config();
            draw_config_all_cursor();
        }
        break;
    case mv_ok:
        // 꽪λפξǲ饿ȥ
        if (config_no == CONFIG_NUM){
            change_game_state(gs_demo);
        }
        else {
            // 벼ưϤ줿Ȥˤ
            move = mv_down;
            return;
        }
        break;
    default:
        break;
    }
    move = mv_none;
}


void redraw(void){
    int x, y;
    printf("redraw\n");

    draw_screen();
    for (y = 0 ; y < STAGE_HEIGHT ; y++){
        for (x = 0 ; x < STAGE_WIDTH ; x++){
            patput(x, y, map[x][y].pat);
        }
    }
    switch (game_state){
    case gs_playing:
        put_piece();
        break;
    default:
        break;
    }
}

pat_no_t select_new_block(void){
    int r;
    block_type_t bt;

    r = rnd(0, 99);
    bt = prob_table[r];
    switch (bt) {
    // 
    case bt_fire:
        return pt_fire;
    // 
    case bt_bomb:
        return pt_bomb;
    // Ƴ
    case bt_fuse4:
        return pt_ldru;
    case bt_fuse3:
        r = rnd(0, 3);
        switch (r){
        case 0:
            return pt_xdru;
        case 1:
            return pt_lxru;
        case 2:
            return pt_ldxu;
        case 3:
            return pt_ldrx;
        }
    case bt_fuse2:
        r = rnd(0, 5);
        switch (r){
        case 0:
            return pt_xxru;
        case 1:
            return pt_lxxu;
        case 2:
            return pt_ldxx;
        case 3:
            return pt_xdrx;
        case 4:
            return pt_lxrx;
        case 5:
            return pt_xdxu;
        }
    case bt_fuse1:
        r = rnd(0, 3);
        switch (r){
        case 0:
            return pt_lxxx;
        case 1:
            return pt_xdxx;
        case 2:
            return pt_xxrx;
        case 3:
            return pt_xxxu;
        }
    default:
        puts("Illegal block type.");
        exit(1);
    }
}

void make_next_piece(void){
    int i;
    for (i = 0 ; i < 2 ; i++){
        next_piece.blocks.pat[i] = select_new_block();
    }
}

int make_new_piece(void){
    piece = next_piece;
    make_next_piece();
    put_next_piece();
    if (config.options[ci_piece_init_pos] == 0){
        piece.blocks.pos[0].x = 5;
    }
    else {
        piece.blocks.pos[0].x = rnd(1, STAGE_WIDTH-2);
    }
    piece.blocks.pos[0].y = 1;
    piece.blocks.dir = 0;
    piece.drop_count = 0;
    piece.fall_ix = -1;
    drop_speed = drop_speed_org;
    set_b2_pos();
    put_piece();
    save_blocks();
    if (check_map(piece.blocks.pos[0]) != pt_back){
        return -1;
    }
    else {
        return 0;
    }
}

void set_b2_pos(void){
    printf("dir:%d\n", piece.blocks.dir);
    piece.blocks.pos[1].x = piece.blocks.pos[0].x + RotX(piece.blocks.dir);
    piece.blocks.pos[1].y = piece.blocks.pos[0].y + RotY(piece.blocks.dir);
}

void save_blocks(void){
    blocks_old = piece.blocks;
}


void restore_blocks(void){
    piece.blocks = blocks_old;
}

// pos1, pos2פ0֤
int compare_pos(pos_t pos1, pos_t pos2){
    //    printf("compare:(%d,%d) x (%d,%d)\n", pos1.x, pos1.y, pos2.x, pos2.y);
    if (pos1.x == pos2.x && pos1.y == pos2.y){
        return 0;
    }
    else {
        return -1;
    }
}


int blocks_moved(void){
    // dirפb2ӤϾάǤ
    if (piece.blocks.pos[0].x == blocks_old.pos[0].x &&
        piece.blocks.pos[0].y == blocks_old.pos[0].y &&
        piece.blocks.dir == blocks_old.dir)
    {
        return 0;
    }
    else {
        return -1;
    }
}


void put_piece(void){
    int i;
    for (i = 0 ; i < 2 ; i++){
        //        set_chr(piece.blocks.pos[i], piece.pat[i]);
        patput(piece.blocks.pos[i].x, piece.blocks.pos[i].y,
               piece.blocks.pat[i]);
    }
    if (enable_blastoff){
        EzSetColorByRGB(255, 255, 0);
    }
    else {
        EzSetColorByRGB(180,180,180);
    }
    draw_piece_frame(piece.blocks.pos[0].x, piece.blocks.pos[0].y,
                     piece.blocks.pos[1].x, piece.blocks.pos[1].y);
}

void put_next_piece(void){
    int i;
    for (i = 0 ; i < 2 ; i++){
        //        set_chr(piece.blocks.pos[i], piece.pat[i]);
        patput(STAGE_WIDTH+1, 5-i, next_piece.blocks.pat[i]);
    }
}

void erase_piece(void){
    int i;
    for (i = 0 ; i < 2 ; i++){
        // ĤɻߤΤᡢ
        // Ǥΰ֤putpatʤ顢õϾά
        if (compare_pos(blocks_old.pos[i], piece.blocks.pos[1-i]) != 0){
            patput(blocks_old.pos[i].x, blocks_old.pos[i].y, pt_back);
        //            put_chr(blocks_old.pos[i], pt_back);
        }
    }
}

// 饯ɸpos˥饯no(+mapؤΥå)
void put_chr(pos_t pos, pat_no_t no){
    assert(pos.x < STAGE_WIDTH);
    assert(pos.y < STAGE_HEIGHT);
    //    printf("putchr(%d,%d), %d\n", pos.x, pos.y, no);
    patput(pos.x, pos.y, no);
    set_block(pos, no);
}

// 饯ɸold_posΥ饯new_pos˰ư
// new_posˤ褹뤬old_posˤpt_backmapإåȤ褷ʤ
//   (֥å³ƾʥ֥å褹ȤĤ򤱤뤿)
// Сold_posؤpt_backΥåȤ餷ʤ
//   move_chrˤϡǸpt_backưƽ뤿ᡣ
void move_chr(pos_t old_pos, pos_t new_pos){

    printf("move_chr (%d,%d)->(%d,%d)\n", 
           old_pos.x, old_pos.y, new_pos.x, new_pos.y);
    move_map(old_pos, new_pos);

    patput(new_pos.x, new_pos.y, map[new_pos.x][new_pos.y].pat);
    //    set_block(pos, no);
    printf("move_chr end\n");
}

void insert_line(void){
    pos_t pos, new_pos;
    pat_no_t no;
    put_console("insert line!");
    for (pos.x = 1 ; pos.x < STAGE_WIDTH-1 ; pos.x++){
        for (pos.y = 1 ; pos.y < STAGE_HEIGHT-1 ; pos.y++){
            new_pos = pos;
            new_pos.y --;
            move_chr(pos, new_pos);
        }
    }
    pos.y = STAGE_HEIGHT-2;
    for (pos.x = 1 ; pos.x < STAGE_WIDTH-1 ; pos.x++){
        do {
            no = select_new_block();
        } while (no == pt_fire);
        put_chr(pos, no);
    }
    // ǾʤޤǤ夬ä֥åϥ֤ȶ˾ä
    pos.y = 0;
    for (pos.x = 1 ; pos.x < STAGE_WIDTH-1 ; pos.x++){
        destroy_block(pos);
    }
    // ơΤ뤹뤿ԡäƤΤ褷Ƥ
    put_piece();
    puts ("insert_line end.");
}


pat_no_t check_map(pos_t pos){
    return map[pos.x][pos.y].pat;
}

void set_map(pos_t pos, pat_no_t no){
    job_type_t type;

    /*
    if (no == pt_back){
        if (map[pos.x][pos.y].pat != pt_back){
            map_obj_num --;
        }
    }
    else {
        if (map[pos.x][pos.y].pat == pt_back){
            map_obj_num ++;
        }
        }
    */
    update_map_obj_num(map[pos.x][pos.y].pat, no);

    map[pos.x][pos.y].pat = no;
    for (type = jt_begin ; type < jt_end ; type++){
        map[pos.x][pos.y].job[type] = NULL;
    }
}

// СǤˤѤƱǤɬpt_backmoveǽΤǡ
// old_posmapƤpt_backľʤmap_obj_numΥȤold_posʬϿʤ
void move_map(pos_t old_pos, pos_t new_pos){
    job_type_t type;
    job_t *job;

    assert(old_pos.x < STAGE_WIDTH);
    assert(old_pos.y < STAGE_HEIGHT);
    assert(new_pos.x < STAGE_WIDTH);
    assert(new_pos.y < STAGE_HEIGHT);
    // new_pospatold_pospatǾ񤭤ʬΥ
    update_map_obj_num(map[new_pos.x][new_pos.y].pat, map[old_pos.x][old_pos.y].pat);

    map[new_pos.x][new_pos.y] = map[old_pos.x][old_pos.y];
    

    // ư֥åγƥ֤Фpos򹹿
    for (type = jt_begin ; type < jt_end ; type++){
        job = map[new_pos.x][new_pos.y].job[type];
        if (job != NULL){
            map[new_pos.x][new_pos.y].job[type]->pos = new_pos;
        }
    }
}

void update_map_obj_num(pat_no_t old_no, pat_no_t new_no){
    char buf[256];

    // ʳBlastOff򤷤ʤ
    if (game_state != gs_playing){
        return;
    }
    if (old_no == pt_back && new_no != pt_back){
        map_obj_num ++;
        if (map_obj_num >= BLASTOFF_RESET_BLOCK_NUM && enable_blastoff == FALSE){
            enable_blastoff = TRUE;
            put_console("Blast Offǽ");
        }
    }
    else if (old_no != pt_back && new_no == pt_back){
        map_obj_num --;
        if (map_obj_num == 0 && enable_blastoff == TRUE){
            sprintf(buf, "Blast Off!!");
            put_console(buf);
            sprintf(buf, "  +%d x %d", BLASTOFF_BASE, level);
            put_console(buf);
            add_score(BLASTOFF_BASE * level);
            enable_blastoff = FALSE;
            blastoff_num ++;
            if (achievements.top_blastoff < blastoff_num){
                achievements.top_blastoff =  blastoff_num;
            }
            achievements.total_blastoff ++;
        }
    }
}

void set_map_job(pos_t pos, job_type_t type, job_t *job){
    map[pos.x][pos.y].job[type] = job;
}
void reset_map_job(pos_t pos, job_type_t type){
    map[pos.x][pos.y].job[type] = NULL;
}
job_t *get_map_job(pos_t pos, job_type_t type){
    return map[pos.x][pos.y].job[type];
}


// Ϥ֥å
// set_mapǥ֥å֤ǡȯдϢԤ
void set_block(pos_t pos, pat_no_t no){
    //    int i;
    job_t *job;

    set_map(pos, no);
    switch (no) {
    case pt_fire:
        job = create_job(jt_fire, pos);
        job->count = JOB_FIRE_COUNT;
        break;
    case pt_bomb:
        break;
    case pt_bomb2:
        job = create_job(jt_bomb, pos);
        job->count = JOB_BOMB_COUNT;
        job->point = POINT_BOMB;
        job->combo = 1;
        break;
    case pt_wall:
    case pt_back:
    case pt_act_cursor:
    case pt_nact_cursor:
        // ɤطֻϤʤˤ⤷ʤ
        break;
    // ƳΤȤ
    default:
        if (IsFuse(no)){
            break;
        }
        else {
            printf("Unknown block:%d\n", no);
            exit(1);
        }
    }
}

// ֥å˲
// Υ֥åΥ֤򤹤٤ƺƤ顢ΰ֤pt_back򥻥åȤ
void destroy_block(pos_t pos){
    job_type_t type;
    job_t *job;

    //    printf("destroy block %d(%d,%d)\n", check_map(pos), pos.x, pos.y);
    for (type = jt_begin ; type < jt_end ; type++){
        job = map[pos.x][pos.y].job[type];
        if (job != NULL){
            //            printf("remove job type %d %p\n", type, job);
            destroy_job(job);
        }
    }
    put_chr(pos, pt_back);
}


void process_job(void){
    // ׺ߤΥ֥塼ˤfirefuse / fusefireʤ
    // ˤäƷ̤̯˱ƶΤǡ
    // ˥塼ʬƷޤä˽Ƥ
    process_job_fire();
    process_job_bomb();
    process_job_fuse();
    process_job_fall();
    // եȤ¾Ǥ˾񤭤ΤǡȯϺǸˤ
    process_job_blast();
}


void process_job_fire(void){
    int dir;
    pos_t check_pos;
    job_t *job, *new_job, *job_tmp;
    pat_no_t no;

    job = job_queue[jt_fire];
    //    if (job != NULL) {printf("process job:%p\n", job);}

    while (job != NULL){
        //        printf("FIRE JOB:%d\n", job->count);
        (job->count)--;
        if (job->count == 0){
            // Фܥޥå
            for (dir = 0 ; dir < 4 ; dir ++){
                check_pos.x = job->pos.x + RotX(dir);
                check_pos.y = job->pos.y + RotY(dir);
                no = check_map(check_pos);
                // ̤С̤ȯƤʤФ
                if (IsBomb(no)){
                    put_chr(check_pos, pt_bomb2);
                    printf("set fire on bomb %d\n", dir);
                }
                else if (IsFuse(no)){
                    printf("set fire on fuse %d\n", dir);
                    fire_fuse(check_pos, dir, POINT_FUSE, 0);
                }
            }
            // 
            check_pos = job->pos;
            check_pos.y --;
            if (check_map(check_pos) != pt_back){
                new_job = create_job(jt_fall, check_pos);
            }
            // Фä
            put_chr(job->pos, pt_back);
            // Хֺ
            job_tmp = job;
            job = job->next;
            destroy_job(job_tmp);
        }
        else {
            job = job->next;
        }
    }
}


void process_job_bomb(void){
    job_t *job, *new_job, *job_tmp;

    job = job_queue[jt_bomb];
    //    if (job != NULL) {printf("process job:%p\n", job);}

    while (job != NULL){
        //        printf("BOMB JOB:%d\n", job->count);
        (job->count)--;
        if (job->count == 0){
            /*
            // ƾõ
            // ȯλ˾äͶоݤȸǧ뤿ᡢ
            // ȯϻ˾äƤ
            // !!! äѤäʤ
            //            put_chr(job->pos, pt_back);
            */
            // ȯ
            new_job = create_job(jt_blast, job->pos);
            new_job->count = JOB_BLAST_COUNT;
            // bombblastؤΰܹԻˤpointѾ
            new_job->point = job->point;
            new_job->combo = job->combo;
            // ƥֺ
            job_tmp = job;
            job = job->next;
            destroy_job(job_tmp);
        }
        else {
            job = job->next;
        }
    }
}


void process_job_blast(void){
    job_t *job, *job_tmp, *new_job;
    pos_t check_pos;
    char buf[256];
    int i, redraw_piece = FALSE;

    job = job_queue[jt_blast];
    //    if (job != NULL) {printf("process job:%p (%d, %d)\n", job,
    //                             job->pos.x, job->pos.y);}

    while (job != NULL){
        //        printf("BLAST JOB:%p %d\n", job, job->count);
        (job->count)--;
        //        if (job->count <= 0){
        if (job->count == 0){
            // ϥ֥åä
            for (check_pos.y = job->pos.y - 1 ;
                 check_pos.y <= job->pos.y + 1 ;
                 check_pos.y ++)
            {
                for (check_pos.x = job->pos.x - 1 ;
                     check_pos.x <= job->pos.x + 1 ;
                     check_pos.x ++)
                {
                    switch (check_map(check_pos)) {
                    case pt_wall:
                        // ɤȯǾäʤΤǲ⤷ʤ
                        break;
                    // ƤͶ
                    // !! bomb֤ϥåפľblast
                    // ϤԤȯˤޤʤ
                    // 䤳ΤǡȤꤢbomb٥ȤˤƤ
                    case pt_bomb:
                        // ̤С̤ȯƤФΤ֤
                        put_chr(check_pos, pt_bomb2);
                        assert(check_pos.x != job->pos.x || 
                               check_pos.y != job->pos.y);
                        // Ϣ
                        new_job = get_map_job(check_pos, jt_bomb);
                        new_job->point= job->point * POINT_BOMB_COMBO_MULTI;
                        new_job->combo = job->combo + 1;
                        // Ƥ褦ˤƤ
                        new_job = create_job(jt_fall, check_pos);
                        break;
                    case pt_bomb2:
                        // ǤˤƤbomb, blast٥Ȥ
                        // ϤƤʤˤ⤷ʤ
                        break;
                    default:
                        destroy_block(check_pos);
                        break;
                    }
                }
            }
            // ΥԡޤƤɽ
            for (i = 0 ; i < 2 ; i++){
                if (abs(job->pos.x - piece.blocks.pos[i].x) <= 1 &&
                    abs(job->pos.y - piece.blocks.pos[i].y) <= 1)
                {
                    redraw_piece = TRUE;
                    break;
                }
            }
            if (redraw_piece){
                put_piece();
            }
            // 
            check_pos.y = job->pos.y - 2;
            // Yɸ0,1ˤϥ֥åѤޤʤΤ֤ʤ
            if (check_pos.y > 1){
                for (check_pos.x = job->pos.x - 1 ;
                     check_pos.x <= job->pos.x + 1 ;
                     check_pos.x ++)
                    {
                        if (check_map(check_pos) != pt_back){
                            new_job = create_job(jt_fall, check_pos);
                        }
                    }
            }
            // û
            if (job->combo > 1){
                sprintf(buf, "%dϢ +%d", job->combo, job->point);
                // ϢϿ
                if (achievements.top_bomb_combo < job->combo){
                    achievements.top_bomb_combo = job->combo;
                }
            }
            else {
                sprintf(buf, "+%d", job->point);
            }
            put_console(buf);
            add_score(job->point);
            // Ͽ
            if (achievements.top_point < job->point){
                achievements.top_point = job->point;
            }
            // ˿߻
            blast_num ++;
            if (achievements.top_blast < blast_num){
                achievements.top_blast =  blast_num;
            }
            achievements.total_blast ++;
            // ȯֺ(Ƥ뤳ȤǡΥ֤ä)
            job_tmp = job;
            job = job->next;
            printf("destroy blasted bomb %p(%d,%d)\n", job_tmp, job_tmp->pos.x, job_tmp->pos.y);
            destroy_block(job_tmp->pos);
            //            destroy_job(job_tmp);
            // ٥륢å׽
            blast_count ++;
            if (blast_count == LEVEL_UP_COUNT){
                put_console("٥륢å");
                inc_level();
                blast_count = 0;
            }
        }
        else {
            draw_blast(job->pos, job->count);
            job = job->next;
        }
    }
}


void process_job_fuse(void){
    int dir, new_dir;
    pos_t check_pos;
    pat_no_t no;
    job_t *job, *job_tmp, *new_job;
    char buf[256];

    job = job_queue[jt_fuse];
    //    if (job != NULL) {printf("process job:%p\n", job);}

    while (job != NULL){
        //        printf("FUSE JOB:(%d,%d) left:%d\n", job->pos.x, job->pos.y,
        //               job->fuse_left);
        no = check_map(job->pos);
        for (dir = 0 ; dir < 4 ; dir ++){
            if (job->fuse_incount[dir] > 0){
                erase_fuse_fire(job->pos, dir, job->fuse_incount[dir], 1);
                job->fuse_incount[dir] ++;
                draw_fuse_fire(job->pos, dir, job->fuse_incount[dir], 1);
            }
            if (job->fuse_outcount[dir] > 0){
                erase_fuse_fire(job->pos, dir, job->fuse_outcount[dir], 0);
                job->fuse_outcount[dir] ++;
                draw_fuse_fire(job->pos, dir, job->fuse_outcount[dir], 0);
            }
            // αƤ濴ãƱޤ򳰸˱ƤƤʤ
            if (job->fuse_incount[dir] > FUSE_BRANCH_LEN &&
                job->fuse_outcount[dir] == 0)
            {
                // λޤǳԤ
                job->fuse_incount[dir] = -1;
                job->fuse_outcount[dir] = -1;
                job->fuse_left --;
                printf("fuse in dir:%d burn out\n", dir);
                // ĤλޤˤĤơαƤ򳫻
                for (new_dir = 0 ; new_dir < 4 ; new_dir++){
                    if (job->fuse_outcount[new_dir] == 0 &&
                        IsFuseDirected(no, new_dir)){
                        job->fuse_outcount[new_dir] = 1;
                    }
                }
            }
            // αƤüãƱޤ˱ƤƤʤ
            else if (job->fuse_outcount[dir] > FUSE_BRANCH_LEN &&
                job->fuse_incount[dir] == 0)
            {
                // λޤǳԤ
                job->fuse_incount[dir] = -1;
                job->fuse_outcount[dir] = -1;
                job->fuse_left --;
                printf("fuse out dir:%d burn out\n", dir);
                // ܤƳƤر
                check_pos.x = job->pos.x + RotX(dir);
                check_pos.y = job->pos.y + RotY(dir);
                no = check_map(check_pos);
                // ̤С̤ȯƤʤФ
                if (IsBomb(no)){
                    put_chr(check_pos, pt_bomb2);
                    printf("set fire from fuse on bomb %d\n", dir);
                    new_job = get_map_job(check_pos, jt_bomb);
                    new_job->point = POINT_BOMB + job->point;

                    sprintf(buf, "Ƴܡʥ");
                    put_console(buf);
                    sprintf(buf, "  %d֥å", job->combo);
                    put_console(buf);
                    sprintf(buf, "    %d", job->point);
                    put_console(buf);
                    // ƳĹϿ
                    if (achievements.top_fuse_combo < job->combo){
                        achievements.top_fuse_combo = job->combo;
                    }
                }
                else if (IsFuse(no)){
                    printf("expand fire on fuse %d\n", dir);
                    fire_fuse(check_pos, dir,
                              job->point * POINT_FUSE_COMBO_MULTI, job->combo);
                }
            }
            // ƱޤȳαƤƱʹԤƤȤ
            else {
                // ξαƤвä餽ǤλޤǳԤ
                if (job->fuse_incount[dir] + job->fuse_outcount[dir]
                    > FUSE_BRANCH_LEN)
                {
                    job->fuse_incount[dir] = -1;
                    job->fuse_outcount[dir] = -1;
                    job->fuse_left --;
                }
            }
        }
        if (job->fuse_left == 0){
            // 
            check_pos = job->pos;
            check_pos.y --;
            if (check_map(check_pos) != pt_back){
                new_job = create_job(jt_fall, check_pos);
            }
            // Ƴä
            put_chr(job->pos, pt_back);
            // Ƴֺ
            job_tmp = job;
            job = job->next;
            destroy_job(job_tmp);
        }
        else {
            job = job->next;
        }
    }
}

void process_job_fall(void){
    job_t *job, *job_tmp;
    pos_t check_pos, pos_tmp;
    pat_no_t no;
    int job_destroyed;
#ifdef ROBUST_FUSE
    pos_t adjacent_pos;
    int adjacent_no;
#endif
    job = job_queue[jt_fall];
    //    if (job != NULL) {printf("process job:%p\n", job);}

    while (job != NULL){
        check_pos = job->pos;
        check_pos.y ++;
        //        printf("fall start\n");
        // å֤οƤ顢
        if (check_map(check_pos) == pt_back){
            job_destroyed = 0;
            pos_tmp = job->pos;
            no = check_map(pos_tmp);
            while (no != pt_back){
                // ȯкѤƤ뤬
                // ȯƤʤ
                if (no == pt_bomb2 &&
                    get_map_job(pos_tmp, jt_blast) != NULL)
                {
                    job_tmp = job;
                    job = job->next;
                    destroy_job(job_tmp);
                    job_destroyed = -1;
                    break;
                }
#ifdef ROBUST_FUSE
                if (IsFuse(no)){
                    printf("fuse falling");
                    adjacent_pos.x = pos_tmp.x-1;
                    adjacent_pos.y = pos_tmp.y;
                    adjacent_no =  check_map(adjacent_pos);
                    printf("%x <- %x\n", adjacent_no, no);
                    if (IsFuse(adjacent_no) &&
                        IsFuseDirected(no, di_left) &&
                        IsFuseConnected(adjacent_no, di_left))
                    {
                        printf("(%d,%d)connected to left(%d,%d)\n",
                               pos_tmp.x, pos_tmp.y,
                               adjacent_pos.x, adjacent_pos.y);
                        job_tmp = job;
                        job = job->next;
                        destroy_job(job_tmp);
                        job_destroyed = -1;
                        break;
                    }
                    adjacent_pos.x = pos_tmp.x+1;
                    adjacent_pos.y = pos_tmp.y;
                    adjacent_no =  check_map(adjacent_pos);
                    printf("%x -> %x\n", no, adjacent_no);
                    if (IsFuse(adjacent_no) &&
                        IsFuseDirected(no, di_right) &&
                        IsFuseConnected(adjacent_no, di_right))
                    {
                        printf("(%d,%d)connected to right(%d,%d)\n",
                               pos_tmp.x, pos_tmp.y,
                               adjacent_pos.x, adjacent_pos.y);
                        job_tmp = job;
                        job = job->next;
                        destroy_job(job_tmp);
                        job_destroyed = -1;
                        break;
                    }
                    if (pos_tmp.y > 0){
                        adjacent_pos.x = pos_tmp.x;
                        adjacent_pos.y = pos_tmp.y-1;
                        adjacent_no =  check_map(adjacent_pos);
                        printf("%x -> %x\n", no, adjacent_no);
                        if (IsFuse(adjacent_no) &&
                            IsFuseDirected(no, di_up) &&
                            IsFuseConnected(adjacent_no, di_up))
                        {
                            printf("(%d,%d)connected to right(%d,%d)\n",
                                   pos_tmp.x, pos_tmp.y,
                                   adjacent_pos.x, adjacent_pos.y);
                            job_tmp = job;
                            job = job->next;
                            destroy_job(job_tmp);
                            job_destroyed = -1;
                            break;
                        }
                    }
                }
#endif

                move_chr(pos_tmp, check_pos);
                //                put_chr(check_pos, no);
                check_pos.y --;
                pos_tmp.y --;
                //                update_job_pos(pos_tmp, check_pos);
                no = check_map(pos_tmp);
            }
            // ǸΥ֥å֤طʤǾä
            // move_chr֤ΰּΤưΤǡ
            //   Ǥjob->pos.yѹɬפϤʤ
            put_chr(check_pos, pt_back);
            // ǸޤǽäȤΥ֤˰ܤ
            if (job_destroyed == 0){
                // ߤޤäȤϥֺ
                // Υ֤˰ܤäƤΤǡʲνϺѤǤ
                job = job->next;
            }
        }
        // ƤʤФΥ֤Ͻλ
        else {
            job_tmp = job;
            job = job->next;
            destroy_job(job_tmp);
        }
    }
}

// dirposƳФ
// posˤƳ֥å¸ߤɬפ
// Ƴ֥ådir³ƤʤϤʤˤⵯʤ
// Ф줿ƳΥ֤ˤϡݥȤȤpointꤵ
void fire_fuse(pos_t pos, int from_dir, int point, int combo){
    int dir;
    pat_no_t no;
    job_t *new_job;

    no = check_map(pos);
    if (IsFuseConnected(no, from_dir)){
        new_job = get_map_job(pos, jt_fuse);
        // Υ֥åƳ̤ȯФʤ饸
        if (new_job == NULL){
            new_job = create_job(jt_fuse, pos);
            // ޤλĤin/outcount
            new_job->fuse_left = CountFuse(no);
            for (dir = 0 ; dir < 4 ; dir ++){
                new_job->fuse_incount[dir]
                    = (dir == ReverseDir(from_dir)) ? 1 : 0;
                new_job->fuse_outcount[dir] = 0;
            }
            new_job->point = point;
            new_job->combo = combo + 1;
        }
        // ǤˤΥ֥åƳȯкѤξ
        else {
            // а֤̤ȯФʤɲä
            // ΰ֤ǤкѤʤʤˤ⤷ʤ
            // (ʤ롩)
            // ǤˤλޤǳԤƤ(-1)
            // ʤˤ⤷ʤ
            // ݥȤϹʤ
            // ʣηϩ餽Υ֥åФ硢
            // ǽФϩΥܥܡʥŬѤ
            if (new_job->fuse_incount[ReverseDir(from_dir)] == 0){
                new_job->fuse_incount[ReverseDir(from_dir)] = 1;
            }
        }
    }
}


void print_queue(job_t *queue){
    job_t *job = queue;
    int ctr = 0;
    if (job != NULL){
        printf("job queue[%d]", job->type);
    }
    while (job != NULL){
        printf("(%p)-", job);
        ctr++;
        job = job->next;
    }
    printf("(nil)[%d]\n", ctr);
}



void draw_top_score(void){
    char buf[16];
    sprintf(buf, "%08d", achievements.top_score);
    EzSetColorByRGB(0, 0, 0);
    EzFillBox(STAGE_WIDTH*24+24+68, 48-16,
              STAGE_WIDTH*24+24+140, 48);
    EzSetColorByRGB(255, 255, 255);
    EzDrawString(STAGE_WIDTH*24+24+68, 48, buf);
}

void draw_score(void){
    char buf[16];
    sprintf(buf, "%08d", score);
    EzSetColorByRGB(0, 0, 0);
    EzFillBox(STAGE_WIDTH*24+24+68, 72-16,
              STAGE_WIDTH*24+24+140, 72);
    EzSetColorByRGB(255, 255, 255);
    EzDrawString(STAGE_WIDTH*24+24+68, 72, buf);
}

void draw_level(void){
    char buf[16];
    sprintf(buf, "     %03d", level);
    EzSetColorByRGB(0, 0, 0);
    EzFillBox(STAGE_WIDTH*24+24+68, 96-16,
              STAGE_WIDTH*24+24+140, 96);
    EzSetColorByRGB(255, 255, 255);
    EzDrawString(STAGE_WIDTH*24+24+68, 96, buf);
}

void set_top_score(int val){
    achievements.top_score = val;
    draw_top_score();
}
void set_score(int val){
    score = val;
    draw_score();
}
void set_level(int val){
    level = 1;
    while (level < val){
        inc_level();
    }
    draw_level();
}

void add_score(int val){
    score += val;
    if (achievements.top_score < score){
        set_top_score(score);
    }
    draw_score();
}
void inc_level(void){
    int is_fast_drop;

    level ++;
    if (achievements.top_level < level){
        achievements.top_level = level;
    }
    // ̾ʤ
    if (drop_speed == drop_speed_org){
        is_fast_drop = FALSE;
    }
    else {
        is_fast_drop = TRUE;
    }
    drop_speed_org -= LEVEL_UP_SPEEDUP;
    if (drop_speed_org < DROP_SPEED_MIN){
        drop_speed_org = DROP_SPEED_INIT;
        //        put_console("®٥ꥻå");
        /*
        prob_old = block_prob[prob_change_bt];
        block_prob[prob_change_bt] -= PROB_CHANGE_UNIT;
        if (block_prob[prob_change_bt] < PROB_MIN){
            block_prob[prob_change_bt] = PROB_MIN;
        }
        block_prob[bt_fuse1] += prob_old - block_prob[prob_change_bt];
        prob_change_bt ++;
        if (prob_change_bt == bt_fuse1){
            prob_change_bt = bt_begin;
        }
        */
        /*
        if (prob_change_bt == bt_bomb){
            if (block_prob[bt_bomb] >= PROB_MIN+PROB_CHANGE_UNIT){
                block_prob[bt_bomb] -= PROB_CHANGE_UNIT;
                block_prob[bt_fuse2] += PROB_CHANGE_UNIT;
                prob_change_bt = bt_fuse4;
            }
        }
        else if (prob_change_bt == bt_fuse4){
            if (block_prob[bt_fuse4] >= PROB_MIN+PROB_CHANGE_UNIT){
                block_prob[bt_fuse4] -= PROB_CHANGE_UNIT;
                block_prob[bt_fuse3] += PROB_CHANGE_UNIT;
                prob_change_bt = bt_bomb;
            }
        }
        else {
            printf("unknown prob_change_bt:%d\n", prob_change_bt);
            exit(1);
        }
        */
        // fuse3, fuse2, fuse1󤺤ϡγΨᤷ
        // insert_line_interval򸺤餹
        if (prob_change_bt == bt_end){
            prob_change_bt = bt_fuse3;
            block_prob[bt_bomb] += PROB_CHANGE_UNIT*3;
            block_prob[bt_fuse3] -= PROB_CHANGE_UNIT;
            block_prob[bt_fuse2] -= PROB_CHANGE_UNIT; 
            block_prob[bt_fuse1] -= PROB_CHANGE_UNIT;
        }
        else {
            block_prob[bt_bomb] -= PROB_CHANGE_UNIT;
            block_prob[prob_change_bt] += PROB_CHANGE_UNIT;
            prob_change_bt ++;
        }
        insert_line_interval --;
        if (insert_line_interval < 1){
            insert_line_interval = INSERT_LINE_INTERVAL_INIT2;
        }
        prob2table();
    }
    // ̾ʤ顢®٤˹碌
    // ®ʤ顢drop_speed<drop_speed_orgʤΤǡΤޤޤˤ
    if (is_fast_drop == FALSE){
        drop_speed = drop_speed_org;
    }
    draw_level();
}

void init_prob(void){
    int i;
    for (i = bt_begin ; i < bt_end ; i++){
        block_prob[i] = block_prob_init[i];
    }
    prob_change_bt = bt_fuse3;
    prob2table();
}


void prob2table(void){
    int i, ix;
    block_type_t bt;

    ix = 0;
    for (bt = bt_begin ; bt < bt_end ; bt++){
        for (i = 0 ; i < block_prob[bt] ; i++){
            prob_table[ix] = bt;
            ix ++;
        }
    }
    // 100ˤʤʤblock_probְͤäƤ
    assert(ix == 100);
    for (i = 0 ; i < 100 ; i++){
        printf("%3d %3d\n", i, prob_table[i]);
    }
}

void show_status(void){
    char buf[256];
    sprintf(buf, "٥륢åפޤ");
    put_console(buf);
    sprintf(buf, "%4dȯ", LEVEL_UP_COUNT - blast_count);
    put_console(buf);
    sprintf(buf, "®%3d", drop_speed);
    put_console(buf);
    sprintf(buf, "夬%2d/%2d", insert_line_countdown, insert_line_interval);
    put_console(buf);
    sprintf(buf, "Blast Off%2d/%2d", map_obj_num, BLASTOFF_RESET_BLOCK_NUM);
    put_console(buf);

    show_prob();
}

void show_prob(void){
    char buf[256];
    char *btname[] = {"fire", "bomb", "fuse4", "fuse3", "fuse2", "fuse1"};
    block_type_t bt;

    put_console("֥åиΨ");
    for(bt = bt_begin ; bt < bt_end ; bt++){
        sprintf(buf, "%-5.5s %3d%%", btname[bt], block_prob[bt]);
        puts(buf);
        put_console(buf);
    }
}

void show_version(void){
    char buf[256];
    //    sprintf(buf, "Ver %.2f %d", (double)VERSION / 100, map_obj_num);
    sprintf(buf, "Ver %.2f", (double)VERSION / 100);
    put_console(buf);
}

void show_job(void){
    char buf[256];
    job_type_t jt;
    job_t *p;
    int n;
    static char *job_name[] = {
        "fire", "bomb", "fuse", "fall", "blast"
    };

    put_console("ְ");
    for (jt = jt_begin ; jt < jt_end ; jt++){
        p = job_queue[jt];
        n = 0;
        while (p != NULL){
            p = p->next;
            n++;
        }
        sprintf(buf, "%-6s %3d", job_name[jt], n);
        put_console(buf);
    }
}

#ifdef DUMMY
//struct timeval st_tv, en_tv;
clock_t time_start, time_end;

void start_timer_handler(void){
    time_start = clock();
    //    gettimeofday(&st_tv, NULL);
}
int set_timer_handler(EzTimerHandler func, long ms){
    /*
    gettimeofday(&en_tv, NULL);
    ms -= (en_tv.tv_sec - st_tv.tv_sec)*1000 +
        (en_tv.tv_usec - st_tv.tv_usec)/1000;
    */
    time_end = clock();
    ms -= (time_end - time_start) * 1000 / CLOCKS_PER_SEC;
    if (ms < 0){
        ms = 0;
    }
    //        printf("%d %d\n", (int)st_tv.tv_sec, (int)st_tv.tv_usec);
    //       printf("%d %d\n", (int)en_tv.tv_sec, (int)en_tv.tv_usec);
#ifdef SHOW_TIMER
        printf("timer:%dmsec\n", (int)ms);
#endif
        EzSetTimerHandler(func, ms);
}
#endif

void show_help(void){
    int i;
    char *msg[] = {
        "=== ˡ ===",
        "ž",
        "",
        " ư",
        "",
        "",
        "[SPACE] ®",
        "Z, X  ž",
        "P     ",
        "Q     ",
        "H,[RET]ɽ",
        "================",
    };
    for(i = 0 ; i < sizeof(msg)/sizeof(char *) ; i++){
        puts(msg[i]);
        put_console(msg[i]);
    }
}


// SAVE_DIR˥⡼modeǥǡեfile򳫤
// 
FILE *open_data(char *file, char *mode){
    char path[512];
    char *home;

    home = getenv("HOME");
    if (home != NULL){
        sprintf(path, "%s/%s", home, SAVE_DIR);
        if (strchr(mode, 'w')){
            if (check_dir(path) == 0){
                printf("Creating directory '%s'...", path);
                if (make_dir(path) == 0){
                    printf("success.\n");
                }
                else {
                    printf("failure.\n");
                    return NULL;
                }
            }
        }
        sprintf(path, "%s/%s/%s", home, SAVE_DIR, file);
    }
    else {
        sprintf(path, "%s/%s", exe_dir, file);
    }
    return fopen(path, mode);
}


int load_achievements(void){
    FILE *fp;
    int file_version = 0;
    
    if ((fp = open_data(ACHIEVEMENTS_FILE, "rb")) == NULL){
        return -1;
    }
    fread(&file_version, sizeof(file_version), 1, fp);
    // ̤ΤΥСʤɤ߹
    if (file_version < 90 || file_version > 200){
        return -1;
    }
    fread(&achievements, sizeof(achievements_t), 1, fp);
    fclose(fp);
    return 0;
}

int save_achievements(void){
    FILE *fp;

    if ((fp = open_data(ACHIEVEMENTS_FILE, "wb")) == NULL){
        return -1;
    }
    fwrite(&version, sizeof(version), 1, fp);
    fwrite(&achievements, sizeof(achievements_t), 1, fp);
    fclose(fp);
    return 0;
}

int load_config(void){
    FILE *fp;
    int file_version = 0;

    if ((fp = open_data(CONFIG_FILE, "rb")) == NULL){
        return -1;
    }
    fread(&file_version, sizeof(file_version), 1, fp);
    // ̤ΤΥСʤɤ߹
    if (file_version < 90 || file_version > 200){
        return -1;
    }
    fread(&config, sizeof(config_t), 1, fp);
    fclose(fp);
    return 0;
}


int save_config(void){
    FILE *fp;

    if ((fp = open_data(CONFIG_FILE, "wb")) == NULL){
        return -1;
    }
    fwrite(&version, sizeof(version), 1, fp);
    fwrite(&config, sizeof(config_t), 1, fp);
    fclose(fp);
    return 0;
}


void draw_achievements(void){
    int i;
    char *str[] = {
        "1εϿ",
        "",
        "٥",
        "˿",
        "ƳĹ",
        "Ϣ",
        "Blast Off",
        "",
        "",
        "  ץ쥤",
        "  ˿",
        "Blast Off",
    };
    char buf[256];

    init_stage();
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < sizeof(str)/sizeof(char*) ; i++){
        draw_bold(PAT_SIZE*1+STAGE_LT_X+2,
                  PAT_SIZE*(i+1)+STAGE_LT_Y-4, str[i]);
    }

    sprintf(buf, "%8d", achievements.top_score);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*2+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_level);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*3+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_blast);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*4+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_fuse_combo);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*5+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_bomb_combo);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*6+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_blastoff);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*7+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.top_point);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*8+STAGE_LT_Y-4, buf);


    sprintf(buf, "%8d", achievements.total_play_num);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*10+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.total_blast);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*11+STAGE_LT_Y-4, buf);
    sprintf(buf, "%8d", achievements.total_blastoff);
    draw_bold(PAT_SIZE*6+STAGE_LT_X+2, PAT_SIZE*12+STAGE_LT_Y-4, buf);

    draw_bold(PAT_SIZE*3+STAGE_LT_X+2, PAT_SIZE*17+STAGE_LT_Y-4, "PUSH ANY KEY");

}


void draw_config(void){
    int i, j;

    //    char buf[256];

    init_stage();
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < CONFIG_NUM ; i++){
        draw_bold(PAT_SIZE*1+STAGE_LT_X+2,
                  PAT_SIZE*(i*2+1)+STAGE_LT_Y-4,
                  config_str[i]);
        for (j = 0 ; j < options_num[i] ; j++){
            draw_bold(PAT_SIZE*2+STAGE_LT_X+2 + PAT_SIZE*8*j/options_num[i],
                      PAT_SIZE*(i*2+2)+STAGE_LT_Y-4, 
                      options_str[i][j]);    
        }
    }
    draw_bold(PAT_SIZE*2+STAGE_LT_X+2,
              PAT_SIZE*(CONFIG_NUM*2+2)+STAGE_LT_Y-4, 
              "꽪λ");
}

void draw_config_cursor(int config_no, int option_no, int is_active){
    pos_t pos;
    pos.x = 1 + 8 * option_no /options_num[config_no];
    pos.y = 1 + config_no*2;
    if (is_active){
        put_chr(pos, pt_act_cursor);
    }
    else {
        put_chr(pos, pt_nact_cursor);
    }
}

void erase_config_cursor(int config_no, int option_no){
    pos_t pos;
    pos.x = 1 + 8 * option_no /options_num[config_no];
    pos.y = 1 + config_no*2;
    put_chr(pos, pt_back);
}


void draw_config_all_cursor(void){
    int i;
    for (i = 0 ; i < CONFIG_NUM ; i ++){
        draw_config_cursor(i, config.options[i], FALSE);
    }
    draw_config_cursor(config_no, option_no, TRUE);
}
